(* Time-stamp: <modified the 14/03/2019 (at 16:01) by Erwan Jahier> *)

open Process

let (f: Process.t list -> string) =
  fun pl ->
    let all = List.map (fun p -> List.map (fun a -> p.pid^"_"^a) p.actions) pl in
    let al = List.flatten all in
    let ins str = String.concat (","^str)
        (List.map (fun al -> String.concat "," (List.map (fun a -> "Enab_"^a) al)) all)
    in
    let outs str = String.concat  (","^str) (List.map (fun al -> String.concat "," al) all) in
    let acti_if_enab = 
      (String.concat " and\n\t\t"
         (List.map
            (fun al ->
               Printf.sprintf "%s"
                 (String.concat " and\n\t\t"
                    (List.map (fun a ->
                         Printf.sprintf "((not Enab_%s) => (not %s))" a a) al)
                 )
            )
            all
         ))
    in
    let all1 = List.filter (fun al -> List.length al > 1) all in
    let one_per_process =  
      (String.concat " and\n\t\t"
         (List.map
            (fun al -> Printf.sprintf "(not (%s))" (String.concat " and " al))
            all1
         ))
    in

    let macro = Printf.sprintf "let demon_prop(%s,\n\t%s:bool):bool =\n\t\t%s and\n\t\t%s"
        (ins "\n\t") (outs "\n\t") acti_if_enab one_per_process 
    in

    let distributed = Printf.sprintf
        "node distributed(%s:bool)\nreturns(%s:bool) =
  assert\n\t\tdemon_prop(%s,%s)\n  in
  loop\n\t{ %s\n\t|> true -- silent!\n  }\n"
        (ins "\n\t") (outs "\n\t") (ins "\n\t\t\t") (outs "\n\t\t\t")
        (String.concat " or " al)
    in
    let synchronous = Printf.sprintf
        "node synchronous(%s:bool)\nreturns(%s:bool) =
  assert\n\t\tdemon_prop(%s,%s)\n  in
  loop\n\t%s\n"  (ins "\n\t") (outs "\n\t") (ins "\n\t\t\t") (outs "\n\t\t\t")
        (String.concat " and\n\t"
         (List.map
            (fun al ->
               Printf.sprintf "%s"
                 (String.concat " and\n\t"
                    (List.map (fun a ->
                         Printf.sprintf "(Enab_%s = %s)" a a) al)
                 )
            )
            all
         ))
    in
    let central = Printf.sprintf
        "(* 
n-ary xor not yet implemented in lutin
node central(%s:bool)\nreturns(\n\t %s:bool) =
  assert\n\t\tdemon_prop(%s,%s)\n  in
  loop \n\txor(%s)\n *)"
        (ins "\n\t\t") (outs "\n\t\t") (ins "\n\t\t\t") (outs "\n\t\t\t")
        (String.concat "," al)
    in
    Printf.sprintf "%s\n\n%s\n%s\n%s\n" macro distributed synchronous central

